<?php
//  ---------------------------------------------------------------------------------
//    _____   _             _                   _   _____
//   |  __ \ | |           | |    /\           (_) |  __ \
//   | |__) || |__    __ _ | |   /  \    _ __   _  | |__) |_ __  ___
//   |  ___/ | '_ \  / _` || |  / /\ \  | '_ \ | | |  ___/| '__|/ _ \
//   | |     | | | || (_| || | / ____ \ | |_) || | | |    | |  | (_) |
//   |_|     |_| |_| \__,_||_|/_/    \_\| .__/ |_| |_|    |_|   \___/
//                                      | |
//                                      |_|
//   PhalApi Pro 专业版
//   广州果创网络科技有限公司
//
//  ---------------------------------------------------------------------------------
//
//   一、协议的许可和权利
//    1. 您可以在完全遵守本协议的基础上，将本软件应用于商业用途；
//    2. 您可以在协议规定的约束和限制范围内修改本产品源代码或界面风格以适应您的要求；
//    3. 您拥有使用本产品中的全部内容资料、商品信息及其他信息的所有权，并独立承担与其内容相关的
//       法律义务；
//    4. 获得商业授权之后，您可以将本软件应用于商业用途，自授权时刻起，在技术支持期限内拥有通过
//       指定的方式获得指定范围内的技术支持服务；
//
//   二、协议的约束和限制
//    1. 未获商业授权之前，禁止将本软件用于商业用途（包括但不限于企业法人经营的产品、经营性产品
//       以及以盈利为目的或实现盈利产品）；
//    2. 未获商业授权之前，禁止在本产品的整体或在任何部分基础上发展任何派生版本、修改版本或第三
//       方版本用于重新开发；
//    3. 如果您未能遵守本协议的条款，您的授权将被终止，所被许可的权利将被收回并承担相应法律责任；
//
//   三、有限担保和免责声明
//    1. 本软件及所附带的文件是作为不提供任何明确的或隐含的赔偿或担保的形式提供的；
//    2. 用户出于自愿而使用本软件，您必须了解使用本软件的风险，在尚未获得商业授权之前，我们不承
//       诺提供任何形式的技术支持、使用担保，也不承担任何因使用本软件而产生问题的相关责任；
//    3. 广州果创网络科技有限公司不对使用本产品构建的商城中的内容信息承担责任，但在不侵犯用户隐
//       私信息的前提下，保留以任何方式获取用户信息及商品信息的权利；
//
//   有关本产品最终用户授权协议、商业授权与技术服务的详细内容，均由广州果创网络科技有限公司独家
//   提供。广州果创网络科技有限公司拥有在不事先通知的情况下，修改授权协议的权力，修改后的协议对
//   改变之日起的新授权用户生效。电子文本形式的授权协议如同双方书面签署的协议一样，具有完全的和
//   等同的法律效力。您一旦开始修改、安装或使用本产品，即被视为完全理解并接受本协议的各项条款，
//   在享有上述条款授予的权力的同时，受到相关的约束和限制。协议许可范围以外的行为，将直接违反本
//   授权协议并构成侵权，我们有权随时终止授权，责令停止损害，并保留追究相关责任的权力。
//
//  ---------------------------------------------------------------------------------

namespace Platform\Api;

use Platform\Common\Api;
use Base\Domain\Apps as AppsDomain;
use PhalApi\Exception\BadRequestException;


/**
 * 开发者应用模块
 */
class Apps extends Api {

    public function getRules() {
        return array(
            'getAppList' => array(
                'appName' => array('name' => 'app_name', 'default' => '', 'max' => 50, 'desc' => '待搜索的应用名称'),
                'page' => array('name' => 'page', 'type' => 'int', 'min' => 1, 'default' => 1, 'desc' => '第几页'),
                'perpage' => array('name' => 'perpage', 'type' => 'int', 'min' => 1, 'max' => 5000, 'default' => 10, 'desc' => '分页数量'),
            ),
            'getAppDropdownList' => array(
                'appName' => array('name' => 'app_name', 'default' => '', 'max' => 50, 'desc' => '待搜索的应用名称'),
            ),
            'cancelApp' => array(
                'cancelAppKey' => array('name' => 'cancel_app_key', 'required' => true, 'desc' => '待注销的app_key'),
            ),
            'addApp' => array(
                'appName' => array('name' => 'appName', 'require' => true, 'max' => 50, 'desc' => '应用名称'),
                'appOwner' => array('name' => 'app_owner', 'require' => true, 'max' => 100, 'desc' => '申请机构'),
                'appIcon' => array('name' => 'app_icon', 'default' => '', 'max' => 255, 'desc' => '应用图标'),
                'applyReason' => array('name' => 'apply_reason', 'require' => true, 'max' => 2000, 'desc' => '申请说明'),
            ),
            'getMyAppInfo' => array(
                'appKey' => array('name' => 'app_key', 'require' => true, 'max' => '64', 'desc' => 'app_key，用于区分客户端应用'),
            ),
            'editMyApp' => array(
                'appKey' => array('name' => 'app_key', 'require' => true, 'max' => '64', 'desc' => 'app_key，用于区分客户端应用'),
                'appName' => array('name' => 'appName', 'require' => true, 'max' => 50, 'desc' => '应用名称'),
                'appOwner' => array('name' => 'app_owner', 'require' => true, 'max' => 100, 'desc' => '申请机构'),
                'appIcon' => array('name' => 'app_icon', 'default' => '', 'max' => 255, 'desc' => '应用图标'),
                'applyReason' => array('name' => 'apply_reason', 'require' => true, 'max' => 2000, 'desc' => '申请说明'),
            ),
        );
    }

    /**
     * 获取所有应用数据
     * @desc 获取所有应用数据
     * @return array list 应用列表，没有时为空数组
     * @return int list[].id        id
     * @return string list[].app_key   应用app_key
     * @return string list[].app_secret        应用app_secret
     * @return string list[].app_name        应用名称
     * @return int list[].app_status        应用状态： 1表示正常使用，0表示注销
     * @return int list[].verify_status        审核状态： 1表示审核通过，0表示待审核，2表示审核失败️
     * @return int left_num        还可以创建的应用数量
     */
    public function getAppList(){
        $uid = $this->tryToGetUid();
        
        $domain = new AppsDomain();
        
        $uid = $this->tryToGetUid();
        $leftNum = max( \PhalApi\DI()->config->get('app.project.dev_max_app_num') - $domain->getUserAppTotalNum($uid), 0);
        
        $list = $domain->getUserAllApp($uid);
        return array('list' => $list, 'left_num' => $leftNum);
    }
    
    /**
     * 获取应用下拉列表
     * @desc 获取应用下拉列表
     * @return array list 应用列表，没有时为空数组
     * @return int list[].id        id
     * @return string list[].app_key   应用app_key
     * @return string list[].app_name        应用名称
     */
    public function getAppDropdownList(){
        $uid = $this->tryToGetUid();
        $domain = new AppsDomain();
        $apps = $domain->getUserAllApp($uid);
        
        $list = array();
        foreach ($apps as $it) {
            $list[] = array(
                'app_key' => $it['app_key'],
                'app_name' => $it['app_name'] 
                . ($it['verify_status'] == 0 ? '('.\PhalApi\T('To Be Reviewed').')' : ($it['verify_status'] == 2 ? '('.\PhalApi\T('Not Passed').')' : ''))
                    . ($it['app_status'] == 0 ? '('.\PhalApi\T('Canceled').')' : ''),
            );
        }
        
        return $list;
    }

    /**
     * 注销应用
     * @desc 应用注释后，接口不能再使用，且需要管理员才能恢复。
     * @return bool is_success 是否修改成功，true表示修改成功，false修改失败
     */
    public function cancelApp(){
        $rs = array('is_success' => false);
        
        $uid = $this->tryToGetUid();
        
        $domain = new AppsDomain();
        $cfg = $domain->getApp($this->cancelAppKey);
        if (!empty($cfg) && $cfg['uid'] == $uid && $cfg['app_status'] == 1) {
            $domain->alterAppStat($cfg['id'], 0);
            $rs['is_success'] = true;
        }
        
        return $rs;
    }

    /**
     * 创建应用
     * @desc 创建应用
     * @return bool is_add 是否新增成功，true表示新增成功，false新增失败
     */
    public function addApp(){
        $rs = array('is_add' => false, 'app_key' => '');
        
        // 检测数量上限
        $domain = new AppsDomain();
        
        $uid = $this->tryToGetUid();
        $curNum = $domain->getUserAppTotalNum($uid);
        if ($curNum >= \PhalApi\DI()->config->get('app.project.dev_max_app_num')) {
            throw new BadRequestException(\PhalApi\T("number of applications created has reached the maximum and no more new applications can be created, please contact the administrator"));
        }
        
        $appKey = \PhalApi\Tool::createRandStr(rand(16, 32));
        $appSecret = \PhalApi\Tool::createRandStr(rand(32, 64));
        
        $moreInfo = array(
            'app_icon' => $this->appIcon,
            'apply_reason' => $this->applyReason,
        );
        
        $appLimit = \PhalApi\DI()->config->get('app.project.default_daily_app_limit');
        if($domain->addApp($this->appName, $appKey, $appSecret, $appLimit, $uid, $this->appOwner, 0, $moreInfo)){
            $rs['is_add'] = true;
            $rs['app_key'] = $appKey;
        }
        
        return $rs;
    }
    
    
    /**
     * 获取我的应用信息
     * @desc 根据app_key获取应用信息
     * @return object info 应用信息，没有时为null
     * @return string info.app_key        应用app_key
     * @return string info.app_secret     应用app_secret
     * @return string info.app_name       应用名称
     * @return int info.app_status        应用状态： 1表示正常使用，0表示禁止🈲️
     * @return string info.add_time       添加时间
     * @return int info.app_limit         应用每日请求限制次数
     * @return string info.app_owner      申请机构/授权机构
     * @return int info.verify_status     审核状态，0待审核1审核通过2审核不通过
     */
    public function getMyAppInfo(){
        $rs = array('info' => null);
        $uid = $this->tryToGetUid();
        $domain = new AppsDomain();
        $data = $domain->getMyApp($uid, $this->appKey);
        if(!empty($data)){
            $rs['info'] = $data;
        }
        return $rs;
    }
    
    /**
     * 修改应用
     * @desc 修改应用信息，仅当审核未通过时才可修改
     * @return bool is_updated 是否更新成功
     */
    public function editMyApp(){
        $rs = array('is_updated' => false);
        $uid = $this->tryToGetUid();
        $domain = new AppsDomain();
        $app = $domain->getMyApp($uid, $this->appKey);
        if(empty($app)) {
            throw new BadRequestException(\PhalApi\T("application does not exist"));
        }
        if ($app['verify_status'] == 1) {
            throw new BadRequestException(\PhalApi\T("'application has been approved and cannot be modified"));
        }
        $updateData = array(
            'app_name' => $this->appName,
            'app_owner' => $this->appOwner,
            'app_icon' => $this->appIcon,
            'apply_reason' => $this->applyReason,
            'verify_status' => 0, // 重新置为待审核
        );
        if ($domain->updateMyApp($uid, $this->appKey, $updateData)) {
            $rs['is_updated'] = true;
        }
        return $rs;
    }

}
